#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <math.h>
#include <string.h>
#include "function.h"
#define FFT_ON 		0x400
#define DATA_SCAN 	0x100
#define DATA_SEND 	0x200

/**************************************************************************
            
**************************************************************************/
extern int NChannels;
extern unsigned int Rate;
extern int FftSize;
extern int DspMemory;
extern int far *Data;
extern int DrawData;
extern int WindowType;
extern int DmaOn;
extern int SpektrLines;
extern int PcMode;
extern int LogOn;
extern int InterpolationOn;
extern int MarkAmpl;
extern int HelpMode, WasHelp;
extern int Window[1024];
extern int Cosinuses[1024];
extern int Sinuses[1024];
extern int NChannelIndex[];
extern int NChannelCur;
extern int NChannelMax;
extern int FftSizeIndex[];
extern int FftIndex;
extern char *WindowName[];
extern int WinLeft[16], WinTop[16], WinLen[16], WinHigh[16];
extern int SpektrLeft[16], SpektrTop[16], SpektrLen[16], SpektrHigh[16];
extern int DataLeft[16], DataTop[16], DataLen[16], DataHigh[16];
extern int TextLeft, TextTop, TextLen, TextHigh;
extern int GWinLeft, GWinTop, GWinLen, GWinHigh;
extern int far TempBuffer[4096];
extern int far FftAdresses[16*3];
extern int PageIndex[16];
extern int ChannelIndex[16];
extern int ScaleFactors[16];
extern int ChanUsil[];
extern FillBpfWindow(void);

int initialize(void);
int show_header(void);
int MemoryAmountTest(void);
int FillChannelIndex(void);
int FillPageIndex(void);
int OrderMemory(void);
int OrderDisplayVariables(void);
int DrawWindow(void);
int CalculateSpektr(int far *spektr, int far *sp, int size);
int DrawDataWindow(int xtop, int ytop, int length, int high, int N, int far *Data);
int DrawSpektrWindow(int xtop, int ytop, int length, int high, int N, int far *Data, int SFactor);
int ReinitParameters(void);
int ReinitBoardParameters(void);
int StartBpf(void);
int DrawParameters(void);
int FillAndSendPcData(void);
int DrawHelpWindow(int key);
int lagrange(int far *ptr1, int far *ptr2, int size1, int size2);
int fill_lagrange(int far *ptr, double x);
long CountScale(int Scale, long Ampl);

int MaxX, MaxY, far data_buffer[640];
int gdriver = DETECT, gmode, errorcode, backcl=BLUE;
int AmplColor=WHITE;

/* 㭪 ॢ ࠭  ᪨ ०		*/
initialize()
{
initgraph(&gdriver, &gmode, "");
if (graphresult() != grOk)
   {
      printf("Graphics error: %s\n", grapherrormsg(errorcode));
      printf("Press any key to halt:");
      getch();
      exit(1);
   }
directvideo=0;
setbkcolor(backcl);
cleardevice();
/* ⠭ ᪨ ६ 		*/
MaxX=getmaxx();
MaxY=getmaxy();

show_header();
return 0;
}


/*    孥 ப ࠭  ⠭ ᪨
   䮭 BGI ଠ	*/
show_header()
{
int mx=20, dx=33, my=30, dy=50;
static int key, h_font;

/* ᫨ 맢  ࠧ  ⠭ 䮭	*/
if(!key)
  {
  key++;
  h_font=installuserfont("TRIP");
  }

settextstyle( h_font, HORIZ_DIR, 0);
setcolor(LIGHTGREEN);
setusercharsize(40, 61, 30, 38);
outtextxy(5, 0, "樮 ணࠬ    ADSP-21xx");
setusercharsize(mx,dx,my,dy);
return 0;
}


/* 㭪 ஢ 
   뢠  ६ DspMemory ᫮ 㦥 ᥣ⮢
     8   뢠 㭪 FillPageIndex();
    ⢨  頥 㫥 祭.			*/
MemoryAmountTest()
{
int i, j, n;

for(i=0; i < 16; i++) /* 横   ᥣ⮢			*/
  {
  for(j=0; j < 8192; j++) Data[j]=i*100;
  WRITE_INT_MEMORY(i,0, 8192, Data);
  }
for(i=n=0; i < 16 && !n; i++) /* 横   ᥣ⮢		*/
  {
  READ_INT_MEMORY(i, 0, 8192, Data);
  for(j=0; j < 8192; j++) if(Data[j] != i*100) { n=1; break;}
  }
if(n)
  {
  if(i != 4)
    {
    for(j=0; j < 8192; j++) Data[j]=0x5566;
    WRITE_INT_MEMORY(2, 0, 8192,  Data);	/* 襬   㥬 ᥣ */
    READ_INT_MEMORY(2, 0, 8192, Data); /* ⠥   ᥣ	        */
    for(j=0; j < 8192; j++) if(Data[j] != 0x5566) return 1;
    DspMemory=1;
    }
  else DspMemory=4;
  }
 else DspMemory=16;

/*  ᨢ 䨧᪨ ᮢ ᥣ⮢ 			*/
FillPageIndex();
return 0;
}

/*  ஢ 						*/
FillChannelIndex()
{
int i;

for(i=0; i < 16; i++) ChannelIndex[i]=i | (ChanUsil[i] << 8);
return 0;
}

/*  ஢ ࠭						*/
FillPageIndex()
{
int i;
for(i=0; i < 16; i++) PageIndex[i]=i;

/* ᫨   ⮨ 8  ,   ᥣ   ࠢ  */
if(DspMemory == 1) PageIndex[0]=2;
return 0;
}

/*************************************************************************
   㭪 ।   
   ᯮ㥬 ६:
	FftSize 	-> ࠧ  (64, 256, 1024)
	DspMemory	-> 㯭 (᫮ ᥣ⮢   8)
	NChannels	-> ᫮  
	PageIndex	-> 䨧᪨  ᥣ⮢
        ChannelIndex	-> 䨧᪨  
   室:
	FftAdresses	-> ᨢ ஥  ᮬ ᥣ, ᬥ饭 
			    
   頥 㫥 祭  ᯥ譮 믮  㫥
    墠⪥ 饩 
**************************************************************************/
OrderMemory()
{
int i, j, k, n, ch;
int FreeBeg1, FreeBeg2, FreeLength;
int ChanPart;

/*   ᥣ(ࠧ  ᥣ - 8 )   ⪠
   , १ࢨ஢  ७ :
       0  2*FftSize   0x1000  0x1000+2*FftSize
   ⮬ ⠭ ६, ।騥 ᢮ ⪨ 	*/
FreeBeg1=FftSize*4; 		/* 砫 ࢮ ᢮ ⪠    */
FreeLength=0x2000-FftSize*4;	/*  ᢮ ⪠  ᫮    */
ChanPart=FreeLength/(FftSize*2);/* ᫮ ,   
				   ⪥                              */

/* ஢ਬ, 墠    ࠧ饭     	*/
if(ChanPart*2*DspMemory < NChannels) return 1;
// 

for(i=ch=0; i < DspMemory; i++) /* 横   ᥣ⮢    */
  {
  /* 横     ࢮ ⪥				*/
  for(j=0; j < ChanPart; j++, ch++)
    {
    FftAdresses[ch*3]=PageIndex[i];
    FftAdresses[ch*3+1]=FreeBeg1+j*FftSize*2;
    FftAdresses[ch*3+2]=ChannelIndex[ch];
    }
  }
return 0;
}

/***************************************************************************
 㭪 । ᪨ न ᯥࠫ   
  묨  ࠭

 ᯮ㥬 ६:
  NChannels	-> ᫮ 
  MaxX		-> ᫮ ᪨ 祪  ਧ⠫
  MaxY		-> ᫮ ᪨ 祪  ⨪
  DrawData	-> ࠧ襭 ᮢ ஬ ᯥ஢ ⠪  

 ⠭ ६:
  SpektrTop 	-> 孨  ⨪ न ᯥ஢
  SpektrLeft  	-> 孨  ਧ⠫ न ᯥ஢
  SpektrHigh	->   ᯥ஢
  SpektrLen	->   ᯥ஢

  DataTop 	-> 孨  ⨪ न 
  DataLeft  	-> 孨  ਧ⠫ न 
  DataHigh	->   
  DataLen	->   

  ᫨ 뢮  ᯥ    ᯮ ᨢ:
  WinTop	-> 孨  ⨪ न 
  WinLeft	-> 孨  ਧ⠫ न 
  WinHigh	->  
  WinLen	->  
***************************************************************************/
OrderDisplayVariables()
{
int i, j, n;

/* ᨢ, ।騥 ᯮ   ࠭  ᨬ
    ᫠ 	*/
int columns[]={0,1,1,0,2,0,0,0, 4,0,0,0,4,0,0,0,4}; /* ᪮쪮 	    */
int lines[]=  {0,1,2,0,2,0,0,0, 2,0,0,0,3,0,0,0,4}; /* ᪮쪮  ⨪ */
int col, lin;
double ScreenHigh=0.8; 	/* ᪮쪮  ⨪쭮   䨪	  */
double ScreenLength=0.99;/* ᪮쪮  ਧ⠫쭮   䨪	  */
double DataSpektr=0.6;  /*  ᪮쪮 ࠧ    ᯥࠫ쭮 */
int data_h, data_l, spektr_h, spektr_l, win_h, win_l;
int y_interval=6, x_interval=5, x_left=6, y_top=35;
int win_x=5, win_y=4;
int x_array[16], y_array[16];

col=columns[NChannels];
lin=lines[NChannels];

/* । ࠧ    			*/
win_h=(MaxY*ScreenHigh-y_interval*lin)/lin;
win_l=(MaxX*ScreenLength-x_interval*col)/col;

/* । ᮫ न    	*/
for(i=0; i < lin; i++)
  for(j=0; j < col; j++)
     {
     x_array[i*col+j]=x_left+j*(win_l+x_interval);
     y_array[i*col+j]=y_top+i*(win_h+y_interval);
     }


TextLeft=5;
TextTop=y_array[NChannels-1]+win_h+y_interval;
TextLen=MaxX-10;
TextHigh=MaxY-TextTop-y_interval;

GWinLeft=x_left;
GWinTop=y_top;
GWinLen=MaxX*ScreenLength;
GWinHigh=TextTop-GWinTop-y_interval;

/* ।  न  ᯥࠬ  묨	*/
if(!DrawData)
  /* ᫨   ᮢ   묨	*/
  for(i=0; i < NChannels; i++)
    {
    SpektrLeft[i]=x_array[i];
    SpektrTop[i]=y_array[i];
    SpektrLen[i]=win_l;
    SpektrHigh[i]=win_h;
    }
  else
    /* ⢥   ,  न 	*/
    for(i=0; i < NChannels; i++)
      {
      WinLeft[i]=x_array[i];
      WinTop[i]=y_array[i];
      WinLen[i]=win_l;
      WinHigh[i]=win_h;

      SpektrLeft[i]=x_array[i]+win_x;
      SpektrTop[i]=y_array[i]+win_y;
      SpektrLen[i]=win_l-win_x*2;
      SpektrHigh[i]=win_h*DataSpektr-win_y*2;

      DataLeft[i]=x_array[i]+win_x;
      DataTop[i]=SpektrTop[i]+SpektrHigh[i]+win_y;
      DataLen[i]=win_l-win_x*2;
      DataHigh[i]=win_h*(1.-DataSpektr)-win_y*2;
      }
return 0;
}


/***************************************************************************
 㭪 ᮢ ᪮ 

ᯮ㥬 ६:
  Data 		->   
  DrawData	->     
  NChannels	-> ᫮ 
  TempBuffer	-> ६ 
***************************************************************************/
DrawWindow()
{
int i, j;
int WinBorderCol=RED;
static int nchannels=-1, draw_data=-1;

/* ᬮਬ 㦭  ᮢ뢠 ࠭				*/
if(nchannels != NChannels || draw_data != DrawData || WasHelp)
  {
  WasHelp=0;
  nchannels=NChannels;
  draw_data=DrawData;
  setfillstyle(SOLID_FILL, BLUE);
  bar(GWinLeft, GWinTop, GWinLeft+GWinLen, GWinTop+GWinHigh);
  }

for(i=0; i < NChannels; i++)
  {
  CalculateSpektr(Data+i*(FftSize+FftSize*DrawData), TempBuffer, FftSize/2);
  DrawSpektrWindow(SpektrLeft[i], SpektrTop[i], SpektrLen[i], SpektrHigh[i],
                   FftSize/2-1, TempBuffer, ScaleFactors[i]);
  if(DrawData)
    { DrawDataWindow(DataLeft[i], DataTop[i], DataLen[i], DataHigh[i],
                     FftSize, Data+i*(FftSize+FftSize*DrawData)+FftSize);

      /* 㥬 ࠬ	*/
      setcolor(WinBorderCol); setlinestyle(0,0,1);
      rectangle(WinLeft[i], WinTop[i], WinLeft[i]+WinLen[i],
                WinTop[i]+WinHigh[i]);
    }
  }
DrawParameters();
return 0;
}

/*********************************************************************
 ᫥ ᯥ :  ⢥ ਬ  ᭮ ॠ쭮  
 ⥩ ᯥ,  ᯥ  ࠢ ⭮ 
  㬬 ⮢ ॠ쭮   ⥩ ᯥ
*********************************************************************/
CalculateSpektr(int far *spektr, int far *sp, int size)
{
int i, far *ptr;
double f;
unsigned long l_real, l_image;

for(i=0, ptr=spektr; i < size; i++)
  {
  l_real=*ptr++;   l_image=*ptr++;
  f=l_real*l_real+l_image*l_image;
  sp[i]=(f > 0.00001) ? sqrt(f) : 0;
  if(LogOn && sp[i]) sp[i]=log10(sp[i]);
  }
return 0;
}


/************************************************
  ᮢ  
*************************************************/
DrawDataWindow(int xtop, int ytop, int length, int high, int N, int far *Data)
{
int i, j, Max, y0;
double step;
int AxeColor=WHITE, BackColor=DARKGRAY, DataColor=YELLOW;
int data_max=640, far *data_ptr;
double f;
char buffer[60];
long LMax;

if(length > data_max) length=data_max;
if(InterpolationOn) lagrange(Data, data_buffer, N, length);
data_ptr=(InterpolationOn) ? data_buffer : Data;

step=(InterpolationOn) ? 1.0 : (double)N/(double)length;

y0=high/2;

/* ⠭ न ᪮ 	*/
setviewport(xtop, ytop, xtop+length, ytop+high, 0);
setfillstyle(SOLID_FILL, BackColor);
bar(0,0,length,high);

/* 㥬 					*/
setcolor(AxeColor); line(0, y0, length, y0); line(0, 0, 0, high);

/*   ᨬ				*/
for(i=Max=0; i < length; i++)
  if(abs(data_ptr[i*step]) > Max) {Max=abs(data_ptr[i*step]);}
    else if(abs(data_ptr[i*step] == -32768)) {Max=32767; break; }
if(!Max) Max=1;

/* 㥬 䨪				*/
 for(i=0, moveto(0, y0), setcolor(DataColor);  i < length; i++)
     lineto(i, (int)(y0-(long)data_ptr[i*step]*(long)y0/(long)Max));

/* 㥬 					*/
setcolor(AxeColor); line(0, y0, length, y0); line(0, 0, 0, high);

/* 뢥  (᫨ 㦭)		*/
if(MarkAmpl)
  {
  sprintf(buffer, "%u", Max >> 4);
  setcolor(AmplColor);
  outtextxy(length-strlen(buffer)*10, 1, buffer);
  }

setviewport(0,0,MaxX,MaxY,1);
return 0;
}

/************************************************
  ᮢ  ᯥ
*************************************************/
DrawSpektrWindow(int xtop, int ytop, int length, int high, int N, int far *Data, int SFactor)
{
unsigned int i, j, Max, y0;
int n1, n2;
int BackColor=DARKGRAY, DataColor=LIGHTRED, AxeColor=WHITE;
int data_max=640, far *data_ptr;
double step;
char buffer[80];
long LMax;

if(length > data_max) length=data_max;
if(InterpolationOn) lagrange(Data, data_buffer, N, length);
data_ptr=(InterpolationOn) ? data_buffer : Data;

step=(InterpolationOn) ? 1.0 : (double)N/(double)length;

/* ⠭ न ᪮ 	*/
setviewport(xtop, ytop, xtop+length, ytop+high, 0);
setfillstyle(SOLID_FILL, BackColor);
bar(0,0,length,high);

/* 㥬 					*/
setcolor(AxeColor); line(0, high, length, high); line(0, 0, 0, high);

/*   ᨬ				*/
for(i=Max=0; i < length; i++) if(abs(data_ptr[i*step]) > Max)
         Max=abs(data_ptr[i*step]);
if(!Max) Max=1;

/* 㥬 䨪				*/
if(SpektrLines) for(i=1, setcolor(DataColor); i < length; i++)
     line(i, (int)(high-(long)data_ptr[i*step]*(long)high/(long)Max), i, high);
  else for(i=0, setcolor(DataColor), moveto(i, high); i < length; i++)
     lineto(i, (int)(high-(long)data_ptr[i*step]*(long)high/(long)Max));

/* 㥬 					*/
setcolor(AxeColor); line(0, high, length, high);  line(0, 0, 0, high);

/* 뢥  (᫨ 㦭)		*/
if(MarkAmpl)
  {
  /*   ᭮ ମ ਬ 㬬 5 㤭 祭
       ᨬ㬠	*/
  for(i=j=0, LMax=0; j < N-1; j++) if(Data[j] > LMax) LMax=Data[i=j];
  n1=i-2; n2=i+2;
  if(n1 < 0) n1=0; if(n2 >= N-1) n2=N-2;
  for(LMax=0, i=n1; i < n2; i++) LMax+=Data[i];

  /* ⠥    ⮬ ⠡ ⥫	*/
  LMax=CountScale(SFactor, LMax);

  /* ⮡ࠧ  祭					*/
  sprintf(buffer, "%lu", LMax);
  setcolor(AmplColor);
  outtextxy(length-strlen(buffer)*10, 1, buffer);
  }

setviewport(0,0,MaxX,MaxY,1);
return 0;
}


/* २樠 ࠬ஢ । 		*/
ReinitParameters()
{
FillPageIndex();	/* ஭㬥㥬 ᥣ		*/
FillChannelIndex();     /* ஭㬥㥬 		*/
OrderMemory();          /* । 		*/
OrderDisplayVariables();/* ।   ࠭	*/
return 0;
}

ReinitBoardParameters()
{
static int fft_size=-1, fft_window=-1, draw_data=-1, pcmode=-1;
static unsigned fft_rate=0, fft_channels=0, fft_ch=0;
int i;

/* ᫨  ᫮ 祪  ⨯   ⠥   ᨭ
    㧨 樥   ᥣ */
if(WindowType != fft_window || fft_size != FftSize || fft_ch != NChannels
   || draw_data != DrawData ||pcmode!=PcMode)
  {
  for(i=0, FillBpfWindow(), ReinitParameters(); i < DspMemory; i++)
     {
     /* 㧨   ᨭ  			*/
     WRITE_INT_MEMORY(PageIndex[i], FftSize*2, FftSize/2, Cosinuses);
     WRITE_INT_MEMORY(PageIndex[i], FftSize*2+FftSize/2, FftSize/2, Sinuses);
     WRITE_INT_MEMORY(PageIndex[i], FftSize*3, FftSize,  Window);
     }

   /* ⠭ ࠬ    			*/
   // FFT_CONFIG_MAIN(int Source, int SendSrcData, int FFTDim, int NChannel, int far* CtrlTable);
   FFT_CONFIG_MAIN(!PcMode, DrawData, FftSize, NChannels, FftAdresses);
   // ⪫砥 ᨭ஭ 
   // FFT_CONFIG_SYNC(int SyncMode, int SyncRestart, int SyncLow, int SyncChannel, int SyncValue);
   FFT_CONFIG_SYNC(0, 0, 0, 0, 0);
   // ⪫砥 뢮  
   // FFT_CONFIG_DAC(int DACMode, int DACChannel, int Page, int Addr, int Len);
   FFT_CONFIG_DAC(0, 0, 0, 0, 0);
   }
fft_size=FftSize;
fft_window=WindowType;
fft_ch=NChannels;
draw_data=DrawData;
pcmode=PcMode;

if(fft_rate != Rate || fft_channels != NChannels)
  {
  fft_rate=Rate;
  fft_channels=NChannels;
  }
return 0;
}

/*    	*/
StartBpf()
{
int i;

/* ᫨  ନ PC  ନ㥬   ।  	*/
if(PcMode) FillAndSendPcData();

/*   							*/
FFT_START(Rate);

/* ᫨ ࠧ襭     稬 		*/
if(DmaOn) GET_RESULTS_DMA(NChannels*(FftSize+FftSize*DrawData), Data, 0);
return 0;
}

/* 㭪 ᮢ ⥪ ࠬ஢			*/
DrawParameters()
{
int i,j ,k;
static long fft_size=-1, window_type=-1, rate=-1, border=-1;
int x_size, y_size, x_rate, y_rate, x_dma, y_dma, x_window, y_window;
int x_help, y_help;
char buf[30];

x_size=TextLeft+6;
y_rate=y_size=y_window=TextTop+3;

x_rate=TextLeft+190;
x_window=TextLeft+420;

x_help=TextLeft+100;
y_help=TextTop+27;

if(border == -1)
  {
  border=0;
  setcolor(YELLOW);
  setlinestyle(0,0,1);
  rectangle(TextLeft, TextTop, TextLeft+TextLen, TextTop+TextHigh);
  }

setcolor(LIGHTGREEN);
if(fft_size != FftSize || rate != Rate || window_type != WindowType)
  {
  setfillstyle(SOLID_FILL, BLUE);
  bar(TextLeft+1, TextTop+1, TextLeft+TextLen-1, TextTop+TextHigh-1);

  sprintf(buf, "  =%4u", fft_size=FftSize);
  outtextxy(x_size, y_size, buf);

  sprintf(buf, "ࢠ  =%5u ", rate=Rate);
  outtextxy(x_rate, y_rate, buf);

  sprintf(buf, " %s", WindowName[window_type=WindowType]);
  outtextxy(x_window, y_window, buf);

  outtextxy(x_help, y_help, " 'F1'  ᠭ ⨢ ");
  }
return 0;
}

FillAndSendPcData()
{
int i;
double n=20;

/* ᣥ㥬 ᨭ					*/
for(i=0; i<FftSize; i++) TempBuffer[i]=10000.*sin(2.0*M_PI*i*n/FftSize);
WRITE_INT_MEMORY(FftAdresses[0],FftAdresses[1], FftSize, TempBuffer);
return 0;
}

DrawHelpWindow(int key)
{
int i, j, n, x, y, h;
static int ret_v, log_v, win_v, dma_v, size_v, nch_v, data_v, rate_v, int_v;
static int ampl_v;
char buf[100];

x=GWinLeft+8;
y=GWinTop+10;
h=25;

setcolor(LIGHTGREEN);
setfillstyle(SOLID_FILL, DARKGRAY);

if(key)
  {
  bar(GWinLeft, GWinTop, GWinLeft+GWinLen, GWinTop+GWinHigh);

  outtextxy(x, y+=h, "'Esc'          室              ");
  outtextxy(x, y+=h, "'Home'       ⠭ ன  .");
  outtextxy(x, y+=h, "'P'            㧠.");
  ret_v=log_v=win_v=dma_v=size_v=nch_v=data_v=rate_v=int_v=ampl_v=-1;
  }
 else y+=h*3;

y+=h;
if(nch_v != NChannels)
  {
  bar(x,y,MaxX,y+h);
  sprintf(buf, "'SPACE'        ᫠   (N=%d)", NChannels);
  outtextxy(x, y, buf);
  nch_v=NChannels;
  }

y+=h;
if(rate_v != Rate)
  {
  bar(x,y,MaxX,y+h);
  sprintf(buf, "'PgUp', 'PgDn'  ࢠ  (ᥩ=%u)", Rate);
  outtextxy(x, y, buf);
  rate_v=Rate;
  }

y+=h;
if(ret_v != PcMode)
  {
  bar(x,y,MaxX,y+h);
  sprintf(buf, "'Enter'        롮 筨  (ᥩ %s)", (PcMode) ? "" : "");
  outtextxy(x, y, buf);
  ret_v=PcMode;
  }

y+=h;
if(log_v != LogOn)
  {
  bar(x,y,MaxX,y+h);
  sprintf(buf, "'L'            䬨᪨ ⠡ (ᥩ %s)", (LogOn) ? "祭" : "몫祭");
  outtextxy(x, y, buf);
  log_v=LogOn;
  }

y+=h;
if(win_v != WindowType)
  {
  bar(x,y,MaxX,y+h);
  sprintf(buf, "'W'            롮    , ᥩ %s", WindowName[WindowType]);
  outtextxy(x, y, buf);
  win_v=WindowType;
  }

y+=h;
if(dma_v != DmaOn)
  {
  bar(x,y,MaxX,y+h);
  sprintf(buf, "'M'            祭    (ᥩ  %s)", (DmaOn) ? "祭" : "몫祭");
  outtextxy(x, y, buf);
  dma_v=DmaOn;
  }

y+=h;
if(size_v != FftSize)
  {
  bar(x,y,MaxX,y+h);
  sprintf(buf, "'N'            롮 ࠧ୮  (ᥩ  %d)", FftSize);
  outtextxy(x, y, buf);
  size_v=FftSize;
  }

y+=h;
if(data_v != DrawData)
  {
  bar(x,y,MaxX,y+h);
  sprintf(buf, "'D'              ᮢ  (ᥩ %s)", (DrawData) ? "" : " ");
  outtextxy(x, y, buf);
  data_v=DrawData;
  }

y+=h;
if(int_v != InterpolationOn)
  {
  bar(x,y,MaxX,y+h);
  sprintf(buf, "'I'             襭 ௮樨 (ᥩ %s)", (InterpolationOn) ? "ࠧ襭" : " ࠧ襭");
  outtextxy(x, y, buf);
  int_v=InterpolationOn;
  }

y+=h;
if(ampl_v != MarkAmpl)
  {
  bar(x,y,MaxX,y+h);
  sprintf(buf, "'A'             襭 뢮  (ᥩ %s)", (MarkAmpl) ? "ࠧ襭" : " ࠧ襭");
  outtextxy(x, y, buf);
  ampl_v=MarkAmpl;
  }
return 0;
}


lagrange(int far *ptr1, int far *ptr2, int size1, int size2)
/*	 	*/
/*	 4 		*/
{
int i, j, k;
double x;

for(i=0; i < size2; i++)
       {
	j=x=(double)size1*(double)i/(double)size2;
	if(!j)			/*	᫨    ࢠ	*/
		 ptr2[i]=fill_lagrange(&ptr1[0], x);
	   else
	if(j == size1-1)	/*	᫨   ᫥ 	*/
		 ptr2[i]=fill_lagrange(&ptr1[j-3], x-j+3.0);
          else
	  if(j == size1-2)	/*	᫨   ।᫥ 	*/
		 ptr2[i]=fill_lagrange(&ptr1[j-2], x-j+2.0);
	   else
				/*	 ࢠ		*/
		 ptr2[i]=fill_lagrange(&ptr1[j-1], x-j+1.0);
       }
return 0;
}

fill_lagrange(int far *ptr, double x)
{
double y, z, arr[]={-6.0, 2.0, -2.0, 6.0};
int i, j;

for(y=0.0, i=0; i < 4; i++)
	{for(z=1.0, j=0; j < 4; j++) if(j != i) z*=x-j;
	 y+=z*(double)ptr[i]/arr[i];
	}
return (int) y;
}

/* 㭪, ⠭ ⨭ 祭   ᯥ
     ⠡ ⥫
      ᯥ  ᫥  ९
     筮 - 䨪஢ ࠧ  (16 ),
   - ⮣  ६⠡   १
     ᯥࠫ쭮 . ⠡ 䠪 ।
    ᫥ 祭   ᯥ.
    ॢ 室   १⮢ ᯥࠫ쭮  
   ଠ 祭 ᯮ  :
     - 室  室 ᤢ  2  ࠢ
       (  4)
     - १ ᯥࠫ쭮   ᤢ  Scale  
       (᫨ Scale=0  祣 ᤢ  ॡ).
   */
long CountScale(int Scale, long Ampl)
{
if(!Scale) return Ampl;
return Ampl << Scale;
}
